package com.famoco.utils;

public class ByteArrayUtils {
	public static String bytesToHexString(byte[] bArray) {
		return bytesToHexString(bArray, false);
	}
	
	public static String bytesToHexString(byte[] bArray, boolean withSep) {
		StringBuffer sb = new StringBuffer(bArray.length * 2);
		
		for (int i = 0; i < bArray.length; i++) {
			String t = Integer.toHexString(0xFF & bArray[i]);
			if (t.length() < 2)
				sb.append('0');
			sb.append(t.toUpperCase());
			
			if (withSep && i < bArray.length - 1)
				sb.append(' ');
		}
		
		return sb.toString();
	}
	
	public static byte[] fromHexString(String encoded) {
		encoded = encoded.replace(" ", "");
		
	    if ((encoded.length() % 2) != 0)
	        throw new IllegalArgumentException("Input string must contain an even number of characters");

	    final byte result[] = new byte[encoded.length()/2];
	    final char enc[] = encoded.toCharArray();
	    for (int i = 0; i < enc.length; i += 2) {
	        StringBuilder curr = new StringBuilder(2);
	        curr.append(enc[i]).append(enc[i + 1]);
	        result[i/2] = (byte) Integer.parseInt(curr.toString(), 16);
	    }
	    return result;
	}	
	

}
